/*
 * LastAccessTime/LastWriteTime Updater
 *
 *          -- utime --  for Windows 95/98
 *
 *                    Copyright (C) 1997,1998  Shuichi Kitaguchi
 */

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <time.h>

#include "utime.h"


void UpdateTime( const char *filename )
{
  union REGS    ireg,oreg;
  struct SREGS  sreg;
  time_t        t;
  struct tm     *ltm;
#if 0
  char          szCmdLine[_MAX_PATH];
#endif

  /******** int21x function 7143h ********/

  ireg.x.ax = 0x7143;

  sreg.ds   = _FP_SEG(filename); /* file name (segment) */
  ireg.x.dx = _FP_OFF(filename); /* file name (offset) */

  /* get local time */
  time( &t );
  ltm = localtime( &t );

#if 0
  printf("%d/%d/%d %d:%d:%d\n",
	 ltm->tm_year,ltm->tm_mon+1,ltm->tm_mday,
	 ltm->tm_hour,ltm->tm_min,ltm->tm_sec);
#endif

  /*
   * F                0
   * ooooo oooooo ooooo
   * hour  minute second/2
   */
  ireg.x.cx = (ltm->tm_hour<<11)|(ltm->tm_min<<5)|(ltm->tm_sec>>1); /* time */
  /*
   * ooooooo oooo  ooooo
   * 1980+x  month day
   */
  ireg.x.di = ((ltm->tm_year-80)<<9)|((ltm->tm_mon+1)<<5)|ltm->tm_mday;	/* date */

  /* set last write date/time */
  ireg.h.bl = 3;
  intdosx( &ireg, &oreg, &sreg );
#if 0
  printf("set last write date/time ax=[%04x]\n",oreg.x.ax);
#endif

  /* set last access date */
  ireg.h.bl = 5;
  intdosx( &ireg, &oreg, &sreg );
#if 0
  printf("set last access date ax=[%04x]\n",oreg.x.ax);
#endif
  
  exit ( 0 );
}
