/*
 * LastAccessTime/LastWriteTime Updater
 *
 *          -- utime --  for Windows NT
 *
 *                    Copyright (C) 1997,1998  Shuichi Kitaguchi
 */

#include <windows.h>
#include <stdio.h>
#include <process.h>
#include <mbstring.h>

#include "utime.h"


void UpdateTime( const char *lpszFileName )
{
  HANDLE                 hFile;
  FILETIME               ft;
  SYSTEMTIME             st;
  int                    ret=0;
  OSVERSIONINFO          VersionInfo;
  LPSTR                  lpFilePart;
  char                   szComPath[MAX_PATH];
  char                   szUtime9xPath[MAX_PATH];
  DWORD                  dwRet;
  HANDLE                 hModule;
  char                   *pt;

  VersionInfo.dwOSVersionInfoSize = sizeof(VersionInfo);
  GetVersionEx(&VersionInfo);
  switch ( VersionInfo.dwPlatformId ){
  case VER_PLATFORM_WIN32_NT:
    hFile = CreateFile(lpszFileName,
		       GENERIC_WRITE|GENERIC_READ,
		       FILE_SHARE_READ|FILE_SHARE_DELETE,
		       NULL,
		       OPEN_EXISTING,
		       FILE_FLAG_BACKUP_SEMANTICS,
		       NULL);
    if ( hFile == INVALID_HANDLE_VALUE ){
      ret = -1;
    } else {
      GetSystemTime(&st);
      SystemTimeToFileTime(&st,&ft);
      if ( ! SetFileTime(hFile,NULL,&ft,&ft) ) ret = -1;
      CloseHandle(hFile);
    }
    break;
  case VER_PLATFORM_WIN32_WINDOWS:
    dwRet = SearchPath( NULL, "COMMAND.COM", NULL,
			sizeof(szComPath), szComPath, &lpFilePart );
    if ( dwRet == 0 ){
      printf("Error: COMMAND.COM is not found.\n");
      ret = -1;
    } else {
#if 0
      printf("COMMAND.COM is [%s]\n",szComPath );
#endif
      hModule = GetModuleHandle( NULL );
      GetModuleFileName( hModule, szUtime9xPath, sizeof(szUtime9xPath) );
      pt = _mbsrchr( szUtime9xPath, '\\' );
      if ( pt != NULL ) *pt = '\0';
      strcat( szUtime9xPath, "\\" );
      strcat( szUtime9xPath, UTIME_9XNAME );
#if 0
      printf("[%s]\n",szUtime9xPath);
#endif
      ret = _spawnl( _P_WAIT, szComPath, szComPath, "/c",
		     szUtime9xPath, lpszFileName, NULL );
#if 0
      printf("_spawn return code is [%d]\n",ret );
#endif
    }
    break;
  default:
    printf("Unknown Platform.\n");
    break;
  }

  exit ( ret );
}
